// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERMM_CAPS_H
#define _GSTREAMERMM_CAPS_H


#include <glibmm.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gst/gstcaps.h>


namespace Gst
{

struct Structure;

class Caps 
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Caps CppObjectType;
  typedef GstCaps BaseObjectType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


  // For use with Glib::RefPtr<> only.
  void reference()   const;
  void unreference() const;

  ///Provides access to the underlying C instance.
  GstCaps*       gobj();

  ///Provides access to the underlying C instance.
  const GstCaps* gobj() const;

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstCaps* gobj_copy() const;

protected:
  // Do not derive this.  Gst::Caps can neither be constructed nor deleted.
  Caps();
  void operator delete(void*, size_t);

private:
  // noncopyable
  Caps(const Caps&);
  Caps& operator=(const Caps&);


public:
  //TODO: Why doesn't this use _WRAP_CREATE()?
  static Glib::RefPtr<Caps> create();
  static Glib::RefPtr<Caps> create_any();
  static Glib::RefPtr<Caps> create_simple(const Glib::ustring& media_type);

  //TODO: Parameter should be a list of Structures
  static Glib::RefPtr<Caps> create_full(Structure& structure);

  
  Glib::RefPtr<Caps> copy() const;
  
  Glib::RefPtr<Caps> copy_nth(guint nth);
  
  void append(const Glib::RefPtr<Caps>& caps);
  
  void merge(const Glib::RefPtr<Caps>& caps);
  
  void append_structure(Structure& structure);
  
  void merge_structure(Structure& structure);
  //TODO: Shouldn't the Structure be reference-counted?
  
  Structure* get_structure(guint idx);

  
  void remove_structure(guint idx);
  
  guint size() const;

  //TODO: Want to return RefPtr to Caps but using RefPtr in expressions such
  //TODO: as 'caps->set_simple(name1, value1)->set_simple(name2, value2)' a
  //TODO: causes Structure immutability warnings because the Caps is referenced
  //TODO: more than once in the expression
  void set_simple(const Glib::ustring& name, const Glib::ValueBase& value);

  //TODO: Is this method useful? -Jose
  
  void set_simple_valist(char* field, const va_list& varargs);

  
  bool is_any() const;
  
  bool empty() const;
  
  bool fixed() const;
  
  bool equals(const Glib::RefPtr<Caps>& other_caps) const;
  
  bool equals_fixed(const Glib::RefPtr<Caps>& other_caps) const;
  
  bool always_compatible(const Glib::RefPtr<Caps>& other_caps) const;
  
  bool subset(const Glib::RefPtr<Caps>& superset_caps) const;
  
  Glib::RefPtr<Caps> the_intersect(const Glib::RefPtr<Caps>& other_caps) const;
  
  Glib::RefPtr<Caps> the_union(const Glib::RefPtr<Caps>& other_caps) const;
  
  Glib::RefPtr<Caps> normalize();
  
  bool simplify();
  
  xmlNodePtr save(const xmlNodePtr& parent);
  
  static Glib::RefPtr<Caps> load(xmlNodePtr parent);

  
  Glib::ustring to_string() const;

  
  static Glib::RefPtr<Caps> from_string(const Glib::ustring& string);

  
  Glib::RefPtr<Caps> subtract(const Glib::RefPtr<Caps>& subtrahend_caps);
  
  Glib::RefPtr<Caps> make_writable();
  
  void truncate();
  
  
};

} //namespace Gst


namespace Glib
{

  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gst::Caps
   */
  Glib::RefPtr<Gst::Caps> wrap(GstCaps* object, bool take_copy = false);

} // namespace Glib


#endif /* _GSTREAMERMM_CAPS_H */

